#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/select.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <errno.h>




struct RobotPosition {
  float X;
  float Y;
  float Z;
};


int NumRobots;
int RobotSockID[10];
int CricketSockID[10];
int CricketPorts[10];
int CurRobot = 0;
int ListenPort;
char *ExternalIP;
int ListenSocket;


RobotPosition Positions[10];
unsigned int LastUpdate[10];


#define MAXDATASIZE 100 // max number of bytes we can get at once 



// get sockaddr, IPv4 or IPv6:
void *get_in_addr(struct sockaddr *sa) {
  if (sa->sa_family == AF_INET) {
    return &(((struct sockaddr_in*)sa)->sin_addr);
  }
  return &(((struct sockaddr_in6*)sa)->sin6_addr);
}

// connect to all the cricket servers
void Connect_Crickets(void) {
  struct addrinfo hints, *servinfo, *p;
  int rv;
  char s[INET6_ADDRSTRLEN];
 
  for (int i = 0; i < NumRobots; i++) {

    memset(&hints, 0, sizeof hints);
    hints.ai_family = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;

    char port[20];
    sprintf(port, "%d", CricketPorts[i]);
    printf("Connecting to port: %s\n", port);
    if ((rv = getaddrinfo("127.0.0.1", port, &hints, &servinfo)) != 0) {
      fprintf(stderr, "Error getaddrinfo: %s    Cricket server: %d\n", gai_strerror(rv), i);
      exit(1);
    }

    // loop through all the results and connect to the first we can
    for(p = servinfo; p != NULL; p = p->ai_next) {
      if ((CricketSockID[i] = socket(p->ai_family, p->ai_socktype, p->ai_protocol)) == -1) {
	fprintf(stderr, "Error creating socket for cricket server: %d\n", i);
	exit(1);
      }
      
      
      if (connect(CricketSockID[i], p->ai_addr, p->ai_addrlen) == -1) {
	close(CricketSockID[i]);
	fprintf(stderr, "Error connecting to cricket server: %d\n", i);
	exit(1);
      }
      break;
    }


    if (p == NULL) {
      fprintf(stderr, "client: failed to connect to cricket server: %d\n", i);
        exit(1);
    }

    inet_ntop(p->ai_family, get_in_addr((struct sockaddr *)p->ai_addr), s, sizeof(s));
    printf("Connected to java cricket position module: %d\n", i);

    freeaddrinfo(servinfo); // all done with this structure
  }

}

void Close_Crickets(void) {
  for (int i = 0; i < NumRobots; i++) {
    close(CricketSockID[i]);
  }
}

void Setup_ServerSocket(void) {
 int sockfd, new_fd;  // listen on sock_fd, new connection on new_fd
 struct addrinfo hints, *servinfo, *p;
    struct sockaddr_storage their_addr; // connector's address information
    socklen_t sin_size;
    int yes=1;
    char s[INET6_ADDRSTRLEN];
    int rv;

    memset(&hints, 0, sizeof hints);
    hints.ai_family = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags = AI_PASSIVE; // use my IP

    char portbuf[30];
    sprintf(portbuf, "%d", ListenPort);

    if ((rv = getaddrinfo(ExternalIP, portbuf, &hints, &servinfo)) != 0) {
        fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv));
        return;
    }

    // loop through all the results and bind to the first we can
    for(p = servinfo; p != NULL; p = p->ai_next) {
        if ((ListenSocket = socket(p->ai_family, p->ai_socktype,
                p->ai_protocol)) == -1) {
	    printf("Could not create PositionServer listen socket\n");
            exit(1);
        }


        if (setsockopt(ListenSocket, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)) == -1) {
	    printf("Could not set PositionServer listen socket options\n");
            exit(1);
        }

        int on = 1;

        ioctl(ListenSocket, FIONBIO, (char *)&on);

//	fcntl(ListenSocket, F_SETFL, O_NONBLOCK);

        if (bind(ListenSocket, p->ai_addr, p->ai_addrlen) == -1) {
            close(ListenSocket);
            printf("Could not bind to PositionServer Listen socket\n");
	    exit(1);
        }

        break;
    }

    if (p == NULL)  {
        fprintf(stderr, "server: failed to bind\n");
        exit(1);
    }

    freeaddrinfo(servinfo); // all done with this structure

    if (listen(ListenSocket, 1) == -1) {
        perror("listen");
        exit(1);
    }

    printf("Position server: waiting for connections...\n");
/*
        sin_size = sizeof their_addr;
        new_fd = accept(ListenSocket, (struct sockaddr *)&their_addr, &sin_size);
	RobotSockID[CurRobot] = new_fd;
	CurRobot++;

	fcntl(new_fd, F_SETFL, O_NONBLOCK);

        inet_ntop(their_addr.ss_family,
            get_in_addr((struct sockaddr *)&their_addr),
            s, sizeof s);
        printf("Position server: got connection from %s\n", s);


	fcntl(ListenSocket, F_SETFL, O_NONBLOCK);
    */

}


int main(int argc, char *argv[]) {
    int sockfd, numbytes;  
    char buf[MAXDATASIZE];
    int currobot = 0;
    timeval curtime;
    int maxsocket = 0;

    fd_set rfds;
    fd_set afds;
    FD_ZERO(&rfds);
    FD_ZERO(&afds);



    if (argc != 5) {
       printf("Usage: ./PositionServer num_robot cricket_start_port external_server_ip server_port\n");
       return 1;
     }

    NumRobots = atoi(argv[1]);
    int startport = atoi(argv[2]);
    ListenPort = atoi(argv[4]);
    ExternalIP = strdup(argv[3]);
    printf("Waiting for %d robots on port: %d\n", NumRobots, ListenPort);
    
    memset(Positions, 0, sizeof(RobotPosition) * 10);
  

    for (int i = 0; i < NumRobots; i++) {
      CricketPorts[i] = startport + i;
      printf("Communicating with cricket %d on port %d\n", i, CricketPorts[i]);
    }
    Connect_Crickets();
    for (int i = 0; i < NumRobots; i++) {
      FD_SET(CricketSockID[i], &rfds);
    }

    Setup_ServerSocket();
    FD_SET(ListenSocket, &rfds);   
    maxsocket = ListenSocket;

   struct timeval timeout;
   timeout.tv_sec  = 100;
   timeout.tv_usec = 0;

     fd_set working_set;

    char inbuf[100];
    while(1) {
     memcpy(&working_set, &rfds, sizeof(rfds));

      if (select(maxsocket + 1, &working_set, (fd_set *) 0, (fd_set *) 0, (struct timeval *)&timeout) < 0) {
        if (errno == EINTR) {
              continue;
        }
      }

      if (FD_ISSET(ListenSocket, &working_set)) {
       struct sockaddr_storage remoteaddr;       
       socklen_t addrlen = sizeof remoteaddr;
       int newsfd = accept(ListenSocket, (struct sockaddr *)&remoteaddr, &addrlen);
       if (newsfd != -1) { 
         RobotSockID[CurRobot] = newsfd;
         CurRobot++;
         char s[INET6_ADDRSTRLEN];
         inet_ntop(remoteaddr.ss_family, get_in_addr((struct sockaddr *)&remoteaddr), s, sizeof s);
         printf("Position server: got connection from %s   %d\n", s, newsfd);
	 FD_SET(newsfd, &rfds);
         maxsocket = newsfd;
       }
      } 
      else {
      // check for a request from a robot
      for (int i = 0; i < CurRobot; i++) {
         memset(inbuf, 0, 100);

         if (FD_ISSET(RobotSockID[i], &working_set)) {
         int numbytes = recv(RobotSockID[i], inbuf, 99, 0);
            int rnum = atoi(inbuf);
   
	    // if we havent heard from the cricket in a while then send data
            //   indicating so
            gettimeofday(&curtime, NULL);
            if (curtime.tv_sec - LastUpdate[i] > 2) {
               sprintf(inbuf, "(-1.0,-1.0,-1.0)");
            }
            else { 
              sprintf(inbuf, "(%f,%f,%f)", Positions[rnum].X / 100.0f, Positions[rnum].Y / 100.0f, Positions[rnum].Z / 100.f);
            }
	    int bytessent = send(RobotSockID[i], inbuf, strlen(inbuf), 0);
            if (bytessent == -1) {
                printf("Error sending position to robot: %d\n", rnum);
            }
         }
      }
      }
     // see if we have a reading from the crickets
     for (int i = 0; i < NumRobots; i++) {
      if (FD_ISSET(CricketSockID[i], &working_set)) {
       int numbytes = recv(CricketSockID[i], inbuf, 99, 0);
       if (numbytes != 0) {
	  float x=-999, y=-999, z=-999;
          sscanf(inbuf, "(%f,%f,%f)", &x, &y, &z);

          //if (z < 100.0 && z > 0.0) {
	    Positions[i].X = x;
	    Positions[i].Y = y;
            Positions[i].Z = z;

            printf("Got position %f %f %f from cricket %d\n", x, y, z, i);
            fflush(stdin);

            gettimeofday(&curtime, NULL);
            LastUpdate[i] = curtime.tv_sec;
          //}
       }
     }
    }
    }
    Close_Crickets();

    return 0;
}
