#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// This program parses the raw output of the cricketd and shows it in a more friendly output

int main(int argc, char *argv[]) {
  char line[100000];
  char linecopy[100000];
  char *result = NULL, *tresult = NULL;
  FILE *in = NULL;
  bool only_llsq = false;
  double timestamp = 0;

  if (argc > 3) {
    printf("Usage: %s <filename>\n", argv[0]);
  } else if (argc == 2) {
    in = fopen(argv[1], "r");
    if (in == NULL) {
      fprintf(stderr, "Error: Could not open file %s\n", argv[1]);
      exit(EXIT_FAILURE);
    }
  } else {
    in = stdin;
  }
  
  bool llsq = false;
  while (true) {
    result = fgets(line, 99999, in);
    if (result == NULL) break;

    if (strstr(line, "CricketServer1.0") == NULL) {
      //printf("INVALID\n");
      continue;
    }
    strcpy(linecopy, line);
    //printf("%s", line);

    tresult = strtok(linecopy, "|"); // CricketServer 1.0
    tresult = strtok(NULL, "|"); // Timestamp
    timestamp = atof(tresult);

    if (!only_llsq | strstr(line, "llsq-passive") != NULL) printf("Time: %s\t", tresult);

    tresult = strtok(NULL, "|"); // 0/1 ?

    if (strstr(line, "device_pos") != NULL) {
      tresult = strtok(NULL, "|"); // 0/1 ?
      //printf("POSITION type: %s\t", tresult);
      for (int i=0;i<4;i++) {
        tresult = strtok(NULL, "|");
        //printf("SKIP: %s\n", tresult);
      }
    if (!only_llsq | strstr(line, "llsq-passive") != NULL) printf("alg: %s\t", tresult);
    else continue;
 
	  for (int i=0;i<4;i++) tresult = strtok(NULL, "|");
	  if (strstr(line, "ekf-passive") != NULL) { 
        tresult = strtok(NULL, "|");
	   printf("\n");
           continue;
	  } else if (strstr(line, "llsq-passive") != NULL) {
		tresult = strtok(NULL, "|");
		llsq = true;
	  } else {
	  }

      tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      printf("%s\t", tresult);

	  for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
      tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      printf("%s\t", tresult);

	  for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
      tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      printf("%s\t", tresult);
 
      double beaconlist[10] = {0};
      while (true) {
        tresult = strtok(NULL, "|");
        if (tresult == NULL) break;
        if (strstr(tresult, "BEACON") != NULL) {
          int beaconid = tresult[7] - '0';
       		for (int i=0;i<6;i++) {
			tresult = strtok(NULL, "|");
      		}
		beaconlist[beaconid] = atof(tresult);
        }
      }
      for (int i = 1; i < 10; i++) {
        if (beaconlist[i] > 0.0) {
          printf("BEACON-%d %lf", i, beaconlist[i]);
        } else {
          printf("BEACON-%d 0.0", i, beaconlist[i]);
        }
        printf("\t");
      }

	  printf("\n");
      if (llsq == true) {
  	  printf("\n");
	  llsq = false;
      }

    } else if (strstr(line, "BEACON") != NULL) {
      if (only_llsq) continue;

      tresult = strtok(NULL, "|"); // ||
      tresult = strtok(NULL, "|"); // ||
      tresult = strtok(NULL, "|"); // 
      tresult = strtok(NULL, "|"); // 
      if (strstr(line, "cur_space") != NULL) {
        printf("BEACON mode: cur_space\t");
        tresult = strtok(NULL, "|"); // 
      } else if (strstr(line, "stat_est") != NULL) {
        printf("BEACON mode: stat_est\t");
        tresult = strtok(NULL, "|"); // 
      } else {
        printf("BEACON mode: unknown\t");
      }
//	  for (int i=0;i<2;i++) { tresult = strtok(NULL, "|"); }
//	  printf("%s\t", tresult); // Beacon ID
      printf("\n");
      while (true) {
        tresult = strtok(NULL,"|");
        if (tresult == NULL) break;
 
        if (strstr(tresult, "BEACON") != NULL) {
        	printf("\t%.0lf %s: ", timestamp, tresult);
      		for (int i=0;i<11;i++) {
			tresult = strtok(NULL, "|");
        		//printf("SKIP: %s\n", tresult);
      		}
      		tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      		printf("%s\t", tresult); 
      
	  	for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
      		tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      		printf("%s\t", tresult);
      
	  	for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
      		tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      		printf("%s\t", tresult);
      
	  	for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
      		tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      		printf("%s\t", tresult);
      
	  	for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
      		tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      		printf("%s\t", tresult);
      
	  	for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
     		tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
     		printf("%s\t", tresult);
      
	  	for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
      		tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      		printf("%s\t", tresult);
      
		for (int i=0;i<3;i++) tresult = strtok(NULL, "|");
      		tresult[strlen(tresult)>5?5:strlen(tresult)] = '\0';
      		printf("%s\n", tresult);
        }
      }

    } else {
      //printf("NOTHING\n", tresult);
    }
    //printf("LINEDONE\n");
 
  }  

  return EXIT_SUCCESS;
}
