typedef struct {
     int address;  /* if TRUE, reg contains the *address* of the data */
     IOdata_type data_type;
     int size;
     int offset;
     int aligned;
     int byte_swap;
     v_reg_t vc_reg;
     v_reg_t vc_reg2; /* used for paired regs to support non-native data types */
} iogen_oprnd, *iogen_oprnd_ptr;

iogen_oprnd
gen_fetch ARGS((v_reg_t src_reg, int offset, int size,
		IOdata_type data_type, int aligned, int byte_swap));

iogen_oprnd
gen_operand ARGS((v_reg_t src_reg, int offset, int size,
		  IOdata_type data_type, int aligned, int byte_swap));

void
gen_load ARGS((iogen_oprnd_ptr src_oprnd));

void
gen_byte_swap ARGS((iogen_oprnd_ptr src_oprnd));

void
gen_store ARGS((iogen_oprnd src, v_reg_t dest_reg, int offset, int size,
		IOdata_type data_type, int aligned));

void
gen_memcpy ARGS((v_reg_t src, int src_offset, v_reg_t dest,
		 int dest_offset, v_reg_t size));

void
free_oprnd ARGS((iogen_oprnd oprnd));

iogen_oprnd
gen_type_conversion ARGS((iogen_oprnd src_oprnd, IOdata_type data_type));

iogen_oprnd
gen_size_conversion ARGS((iogen_oprnd src_oprnd, int size));

