/**********************************************************************
 **                                                                  **
 **                            RComIDs.h                             **
 **                                                                  **
 **  Written by:  Yoichiro Endo                                      **
 **                                                                  **
 **  The interface class for RCom.                                   **
 **                                                                  **
 **  Copyright 2006 Georgia Tech Research Corporation                **
 **  Atlanta, Georgia  30332-0415                                    **
 **  ALL RIGHTS RESERVED, See file COPYRIGHT for details.            **
 **                                                                  **
 **********************************************************************/
#ifndef RComIDs_H
#define RComIDs_H

/* $Id: RComIDs.h,v 1.1 2008-07-15 22:33:57 endo Exp $ */

#include <string>

#include "RComDefaultSetups.h"

using std::string;

typedef enum RComUserIDs_t {
    RCOM_USER_ID_INVALID = 0,
    RCOM_USER_ID_ROBOT_DUMMY = 1 ,
    RCOM_USER_ID_ROBOT_CAMERA = 2,
    RCOM_USER_ID_ROBOT_SLAMMER = 3,
    RCOM_USER_ID_ROBOT_CONTROL = 4,
    RCOM_USER_ID_ROBOT_MIC = 5,
    RCOM_USER_ID_ROBOT_PANTILT = 6,
    RCOM_USER_ID_ROBOT_ROBOTER = 7,
    RCOM_USER_ID_ROBOT_ROBOTER2 = 8,
    RCOM_USER_ID_ROBOT_SPEEDCONTROL = 9,
	//INSERT NEW ROBOT IDS ABOVE THIS LINE

    RCOM_USER_ID_UCS_DUMMY = 20,
    RCOM_USER_ID_UCS_CAM1 = 21,
    RCOM_USER_ID_UCS_CAM2 = 22,
    RCOM_USER_ID_UCS_CAM3 = 23,
    RCOM_USER_ID_UCS_CAM4 = 24,
    RCOM_USER_ID_UCS_CAM5 = 25,
    RCOM_USER_ID_UCS_CAM6 = 26,
    RCOM_USER_ID_UCS_LASER = 27,
    RCOM_USER_ID_UCS_MAP = 28,
    RCOM_USER_ID_UCS_CONTROL = 29,
    RCOM_USER_ID_UCS_AUDIO = 30,
    RCOM_USER_ID_UCS_RCOMSTATS = 31,
    RCOM_USER_ID_UCS_RCOMSTATS2 = 32,
    //INSERT NEW UCS IDS ABOVE THIS LINE

    RCOM_USER_ID_ROBOT_RCOM = 40,
    RCOM_USER_ID_UCS_RCOM = 41,
    //INSERT RCOM IDS ABOVE THIS LINE

    RCOM_USER_ID_HSERVER = 60,
    //INSERT HSERVER IDS ABOVE THIS LINE

    RCOM_USER_ID_AIR_PERCEPTION = 81,
    RCOM_USER_ID_AIR_BEHAVIORAL = 82
    //INSERT AIR IDS ABOVE THIS LINE
};

#endif
/**********************************************************************
 * $Log: RComIDs.h,v $
 * Revision 1.1  2008-07-15 22:33:57  endo
 * OpenCV, Gazebo and USARSim added.
 *
 * Revision 1.3  2006/11/22 16:06:51  endo
 * Regular update.
 *
 * Revision 1.2  2006/08/31 20:40:01  endo
 * IDs updated.
 *
 * Revision 1.1  2006/08/09 21:12:37  endo
 * RCom added.
 *
 * Revision 1.12  2006/04/14 23:05:59  envarli
 * *** empty log message ***
 *
 * Revision 1.11  2006/04/14 21:08:31  envarli
 * *** empty log message ***
 *
 * Revision 1.10  2006/04/14 21:01:45  envarli
 * *** empty log message ***
 *
 * Revision 1.9  2006/04/14 20:27:31  envarli
 * *** empty log message ***
 *
 * Revision 1.8  2006/04/14 11:24:35  endo
 * RComInterthread::getRComStatus() added.
 *
 * Revision 1.7  2006/04/11 07:05:23  envarli
 * *** empty log message ***
 *
 * Revision 1.6  2006/04/11 06:52:47  envarli
 * *** empty log message ***
 *
 * Revision 1.5  2006/03/08 20:30:35  endo
 * CONSTROL -> CONTROL
 *
 * Revision 1.4  2006/03/01 20:17:36  envarli
 *
 * Modified the enumeration so that numbers are static. Left extra space for new robot
 * and UCS id numbers.
 *
 * Revision 1.3  2006/02/25 22:10:22  endo
 * The user can now specify ports to be used.
 *
 * Revision 1.2  2006/02/24 11:50:33  endo
 * RComm_Controller checked in.
 *
 * Revision 1.1  2006/02/22 07:17:22  endo
 * RComServer and RComClient implemented.
 *
 **********************************************************************/
