/**********************************************************************
 **                                                                  **
 **                       LabelToIdConversions.h                     **
 **                                                                  **
 **                                                                  **
 **  Written by:  Brian Lee                                          **
 **                                                                  **
 **  Copyright 2002 - 2008, Georgia Tech Research Corporation        **
 **  Atlanta, Georgia  30332-0415                                    **
 **  ALL RIGHTS RESERVED, See file COPYRIGHT for details.            **
 **                                                                  **
 **********************************************************************/

/* $Id: LabelToIdConversions.h,v 1.10 2010-05-03 22:12:57 zkira Exp $ */

#ifndef LABELTOIDCONVERSIONS_H
#define LABELTOIDCONVERSIONS_H

#include "HServerConfig.h"

struct SuLabelIdPair
{
    char* szLabel;
    int iId;
};

const SuLabelIdPair asuCAMERA_LABEL_CONVERSIONS[] = 
{
    {"port_string",    ClHServerConfig::EnCameraValueType_PORT_STRING},
    {NULL,             0}
};

const SuLabelIdPair asuLASER_LABEL_CONVERSIONS[] = 
{
    {"name",           ClHServerConfig::EnLaserValueType_NAME},
    {"port_string",    ClHServerConfig::EnLaserValueType_PORT_STRING},
    {"angle_offset",   ClHServerConfig::EnLaserValueType_ANGLE_OFFSET},
    {"x_offset",       ClHServerConfig::EnLaserValueType_X_OFFSET},
    {"y_offset",       ClHServerConfig::EnLaserValueType_Y_OFFSET},
    {"listen_ipt",     ClHServerConfig::EnLaserValueType_LISTEN_IPT},
    {"send_ipt",       ClHServerConfig::EnLaserValueType_SEND_IPT},
    {"stream_host",    ClHServerConfig::EnLaserValueType_STREAM_HOST},
    {NULL,             0}
};

const SuLabelIdPair asuROBOT_LABEL_CONVERSIONS[] = 
{
    {"min_point_turn_angle",           	ClHServerConfig::EnRobotValueType_MIN_POINT_TURN_ANGLE},
    {"max_speed",   			ClHServerConfig::EnRobotValueType_MAX_SPEED},
    {"max_steer_speed",  		ClHServerConfig::EnRobotValueType_MAX_STEER_SPEED},
    {"max_steer_speed_angle",   	ClHServerConfig::EnRobotValueType_MAX_STEER_SPEED_ANGLE},
    {"max_altitude_speed",   		ClHServerConfig::EnRobotValueType_MAX_ALTITUDE_SPEED},
    {"max_no_command_time_sec",   	ClHServerConfig::EnRobotValueType_MAX_NO_COMMAND_TIME_SEC},
    {"min_steer_speed",   		ClHServerConfig::EnRobotValueType_MIN_STEER_SPEED},
    {"stopping_speed_threshold",   	ClHServerConfig::EnRobotValueType_STOPPING_SPEED_THRESHOLD},
    {"num_velocity_samples",	   	ClHServerConfig::EnRobotValueType_NUM_VELOCITY_SAMPLES},
    {NULL,             0}
};

const SuLabelIdPair asuGAZEBO_LABEL_CONVERSIONS[] = 
{
    {"name", ClHServerConfig::EnGazeboValueType_NAME},
    {"truth_name", ClHServerConfig::EnGazeboValueType_TRUTH_NAME},
    {"type", ClHServerConfig::EnGazeboValueType_TYPE},
    {"robot_class", ClHServerConfig::EnGazeboValueType_ROBOT_CLASS},
    {"client_id", ClHServerConfig::EnGazeboValueType_CLIENT_ID},
    {"server_id", ClHServerConfig::EnGazeboValueType_SERVER_ID},
    {"angle_offset", ClHServerConfig::EnGazeboValueType_ANGLE_OFFSET},
    {"x_offset", ClHServerConfig::EnGazeboValueType_X_OFFSET},
    {"y_offset", ClHServerConfig::EnGazeboValueType_Y_OFFSET},
    {"laser_pitch_angle", ClHServerConfig::EnGazeboValueType_LASER_PITCH_ANGLE},
    {"show_image", ClHServerConfig::EnGazeboValueType_SHOW_IMAGE},
    {NULL, 0}
};

const SuLabelIdPair asuUSARSIM_LABEL_CONVERSIONS[] = 
{
    {"host", ClHServerConfig::EnUSARSimValueType_HOST},
    {"name", ClHServerConfig::EnUSARSimValueType_NAME},
    {"robot_class", ClHServerConfig::EnUSARSimValueType_ROBOT_CLASS},
    {"port", ClHServerConfig::EnUSARSimValueType_PORT},
    {"type", ClHServerConfig::EnUSARSimValueType_TYPE},
    {"angle_offset", ClHServerConfig::EnUSARSimValueType_ANGLE_OFFSET},
    {"pos_x", ClHServerConfig::EnUSARSimValueType_POS_X},
    {"pos_y", ClHServerConfig::EnUSARSimValueType_POS_Y},
    {"pos_z", ClHServerConfig::EnUSARSimValueType_POS_Z},
    {"rot_yaw", ClHServerConfig::EnUSARSimValueType_ROT_YAW},
    {"rot_pitch", ClHServerConfig::EnUSARSimValueType_ROT_PITCH},
    {"rot_roll", ClHServerConfig::EnUSARSimValueType_ROT_ROLL},
    {"x_offset", ClHServerConfig::EnUSARSimValueType_X_OFFSET},
    {"y_offset", ClHServerConfig::EnUSARSimValueType_Y_OFFSET},
    {"laser_pitch_angle", ClHServerConfig::EnUSARSimValueType_LASER_PITCH_ANGLE},
    {"show_image", ClHServerConfig::EnUSARSimValueType_SHOW_IMAGE},
    {NULL, 0}
};

const SuLabelIdPair asuROVIO_LABEL_CONVERSIONS[] = 
{
    {"host", ClHServerConfig::EnRovioValueType_HOST},
    {"name", ClHServerConfig::EnRovioValueType_NAME},
    {"robot_class", ClHServerConfig::EnRovioValueType_ROBOT_CLASS},
    {"port", ClHServerConfig::EnRovioValueType_PORT},
    {"type", ClHServerConfig::EnRovioValueType_TYPE},
    {"angle_offset", ClHServerConfig::EnRovioValueType_ANGLE_OFFSET},
    {"pos_x", ClHServerConfig::EnRovioValueType_POS_X},
    {"pos_y", ClHServerConfig::EnRovioValueType_POS_Y},
    {"pos_z", ClHServerConfig::EnRovioValueType_POS_Z},
    {"rot_yaw", ClHServerConfig::EnRovioValueType_ROT_YAW},
    {"rot_pitch", ClHServerConfig::EnRovioValueType_ROT_PITCH},
    {"rot_roll", ClHServerConfig::EnRovioValueType_ROT_ROLL},
    {"x_offset", ClHServerConfig::EnRovioValueType_X_OFFSET},
    {"y_offset", ClHServerConfig::EnRovioValueType_Y_OFFSET},
    {"show_image", ClHServerConfig::EnRovioValueType_SHOW_IMAGE},
    {NULL, 0}
};

const SuLabelIdPair asuSKYBOTIX_LABEL_CONVERSIONS[] =
{
    {"host", ClHServerConfig::EnSkybotixValueType_HOST},
    {"name", ClHServerConfig::EnSkybotixValueType_NAME},
    {"robot_class", ClHServerConfig::EnSkybotixValueType_ROBOT_CLASS},
    {"port", ClHServerConfig::EnSkybotixValueType_PORT},
    {"type", ClHServerConfig::EnSkybotixValueType_TYPE},
    {"angle_offset", ClHServerConfig::EnSkybotixValueType_ANGLE_OFFSET},
    {"pos_x", ClHServerConfig::EnSkybotixValueType_POS_X},
    {"pos_y", ClHServerConfig::EnSkybotixValueType_POS_Y},
    {"pos_z", ClHServerConfig::EnSkybotixValueType_POS_Z},
    {"rot_yaw", ClHServerConfig::EnSkybotixValueType_ROT_YAW},
    {"rot_pitch", ClHServerConfig::EnSkybotixValueType_ROT_PITCH},
    {"rot_roll", ClHServerConfig::EnSkybotixValueType_ROT_ROLL},
    {"x_offset", ClHServerConfig::EnSkybotixValueType_X_OFFSET},
    {"y_offset", ClHServerConfig::EnSkybotixValueType_Y_OFFSET},
    {"show_image", ClHServerConfig::EnSkybotixValueType_SHOW_IMAGE},
    {NULL, 0}
};


const SuLabelIdPair asuOPENCV_LABEL_CONVERSIONS[] = 
{
    {"track_blobs", ClHServerConfig::EnOpenCVValueType_TRACK_BLOBS},
    {"detect_face", ClHServerConfig::EnOpenCVValueType_DETECT_FACE},
    {"detect_objects", ClHServerConfig::EnOpenCVValueType_DETECT_OBJECTS},
    {"direct_grab", ClHServerConfig::EnOpenCVValueType_DIRECT_GRAB},
    {"show_image", ClHServerConfig::EnOpenCVValueType_SHOW_IMAGE},
    {NULL, 0}
};

const SuLabelIdPair asuCOGNACHROME_LABEL_CONVERSIONS[] = 
{
    {"port_string",    ClHServerConfig::EnCognachromeValueType_PORT_STRING},
    {NULL,             0}
};

const SuLabelIdPair asuNOMAD_LABEL_CONVERSIONS[] = 
{
    {"type",           ClHServerConfig::EnNomadValueType_TYPE},
    {"port_string",    ClHServerConfig::EnNomadValueType_PORT_STRING},
    {"host_name",      ClHServerConfig::EnNomadValueType_HOST_NAME},
    {NULL,             0}
};

const SuLabelIdPair asuPIONEER_LABEL_CONVERSIONS[] = 
{
    {"port_string",    ClHServerConfig::EnPioneerValueType_PORT_STRING},
    {NULL,             0}
};

const SuLabelIdPair asuPIONEER2_LABEL_CONVERSIONS[] = 
{
    {"port_string",    ClHServerConfig::EnPioneer2ValueType_PORT_STRING},
    {NULL,             0}
};

const SuLabelIdPair asuAMIGOBOT_LABEL_CONVERSIONS[] = 
{
    {"port_string",    ClHServerConfig::EnAmigoBotValueType_PORT_STRING},
    {NULL,             0}
};

const SuLabelIdPair asuFRAMEGRABBER_LABEL_CONVERSIONS[] = 
{
    {"port_string",    ClHServerConfig::EnFrameGrabberValueType_PORT_STRING},
    {"show_image",     ClHServerConfig::EnFrameGrabberValueType_SHOW_IMAGE},
    {NULL,             0}
};

const SuLabelIdPair asuCRICKET_LABEL_CONVERSIONS[] = 
{
    {"ID",    ClHServerConfig::EnCricketValueType_ID},
    {"IP",     ClHServerConfig::EnCricketValueType_IP},
    {NULL,             0}
};

const SuLabelIdPair asuGPS_LABEL_CONVERSIONS[] = 
{
    {"use_base",       ClHServerConfig::EnGpsValueType_USE_BASE},
    {"port_string",    ClHServerConfig::EnGpsValueType_PORT_STRING},
    {"base_lat",       ClHServerConfig::EnGpsValueType_BASE_LAT},
    {"base_long",      ClHServerConfig::EnGpsValueType_BASE_LONG},
    {"x_diff",         ClHServerConfig::EnGpsValueType_X_DIFF},
    {"y_diff",         ClHServerConfig::EnGpsValueType_Y_DIFF},
    {"m_per_lat",      ClHServerConfig::EnGpsValueType_M_PER_LAT},
    {"m_per_long",     ClHServerConfig::EnGpsValueType_M_PER_LONG},
    {NULL,             0}
};

const SuLabelIdPair asuJBOX_LABEL_CONVERSIONS[] = 
{
    {"jbox_id",        ClHServerConfig::EnJboxValueType_JBOX_ID},
    {"disable_network_query",        ClHServerConfig::EnJboxValueType_DISABLE_NETWORK_QUERY},
    {"gps_section",    ClHServerConfig::EnJboxValueType_GPS_SECTION},
    {NULL,             0}
};

const SuLabelIdPair asuCOMPASS_LABEL_CONVERSIONS[] = 
{
    {"type",           ClHServerConfig::EnCompassValueType_TYPE},
    {"port_string",    ClHServerConfig::EnCompassValueType_PORT_STRING},
    {NULL,             0}
};

const SuLabelIdPair asuGYRO_LABEL_CONVERSIONS[] = 
{
    {"type",           ClHServerConfig::EnGyroValueType_TYPE},
    {NULL,             0}
};

const SuLabelIdPair asuPOSECALC_LABEL_CONVERSIONS[] = 
{
    {"fuser_type",
      ClHServerConfig::EnPoseCalcValueType_FUSER_TYPE},
    {"variance_scheme",
      ClHServerConfig::EnPoseCalcValueType_VARIANCE_SCHEME},
    {"compass2mlab_headingFacor",
     ClHServerConfig::EnPoseCalcValueType_COMPASS2MLAB_HEADING_FACTOR},
    {"compass2mlab_headingOffset",
     ClHServerConfig::EnPoseCalcValueType_COMPASS2MLAB_HEADING_OFFSET},
    {"compass_max_valid_angspeed4heading",
     ClHServerConfig::EnPoseCalcValueType_COMPASS_MAX_VALID_ANGSPEED4HEADING},
    {"gps2mlab_headingFactor",
     ClHServerConfig::EnPoseCalcValueType_GPS2MLAB_HEADING_FACTOR},
    {"gps2mlab_headingOffset",
     ClHServerConfig::EnPoseCalcValueType_GPS2MLAB_HEADING_OFFSET},
    {"gps_min_valid_transspeed4heading",
     ClHServerConfig::EnPoseCalcValueType_GPS_MIN_VALID_TRANSSPEED4HEADING},
    {"gps_max_valid_angspeed4heading",
     ClHServerConfig::EnPoseCalcValueType_GPS_MAX_VALID_ANGSPEED4HEADING},
    {NULL,
     0}
};

const SuLabelIdPair asuSECTION_LABEL_CONVERSIONS[] = 
{
    {"camera",         ClHServerConfig::EnHServerConfigSectionType_CAMERA},
    {"laser",          ClHServerConfig::EnHServerConfigSectionType_LASER},
    {"robot",          ClHServerConfig::EnHServerConfigSectionType_ROBOT},
    {"gazebo",         ClHServerConfig::EnHServerConfigSectionType_GAZEBO},
    {"usarsim",        ClHServerConfig::EnHServerConfigSectionType_USARSIM},
    {"rovio",          ClHServerConfig::EnHServerConfigSectionType_ROVIO},
    {"skybotix",       ClHServerConfig::EnHServerConfigSectionType_SKYBOTIX},
    {"opencv",         ClHServerConfig::EnHServerConfigSectionType_OPENCV},
    {"cognachrome",    ClHServerConfig::EnHServerConfigSectionType_COGNACHROME},
    {"nomad",          ClHServerConfig::EnHServerConfigSectionType_NOMAD},
    {"pioneer",        ClHServerConfig::EnHServerConfigSectionType_PIONEER},
    {"pioneer2",       ClHServerConfig::EnHServerConfigSectionType_PIONEER2},
    {"amigobot",       ClHServerConfig::EnHServerConfigSectionType_AMIGOBOT},
    {"framegrabber",   ClHServerConfig::EnHServerConfigSectionType_FRAMEGRABBER},
    {"jbox",           ClHServerConfig::EnHServerConfigSectionType_JBOX},
    {"gps",            ClHServerConfig::EnHServerConfigSectionType_GPS},
    {"cricket",        ClHServerConfig::EnHServerConfigSectionType_CRICKET},
    {"compass",        ClHServerConfig::EnHServerConfigSectionType_COMPASS},
    {"gyro",           ClHServerConfig::EnHServerConfigSectionType_GYRO},
    {"posecalc",       ClHServerConfig::EnHServerConfigSectionType_POSECALC},
    {NULL,             0}
};

const int NUM_LABEL_ID_PAIRS = 20;

extern const SuLabelIdPair* aasuVALUE_TYPE_CONVERSIONS[NUM_LABEL_ID_PAIRS];

#endif // ifndef LABELTOIDCONVERSIONS_H

/**********************************************************************
# $Log: LabelToIdConversions.h,v $
# Revision 1.10  2010-05-03 22:12:57  zkira
# Addition of rovio & cricket
#
# Revision 1.8  2009/04/17 17:50:05  zkira
# Added max_speed to differentiate it from max_steer_speed
#
# Revision 1.7  2009/04/13 02:58:54  zkira
# max altitude speed & other robot parameters
#
# Revision 1.6  2009/03/02 18:47:08  zkira
# Added ability to change low level robot parameters (e.g. max speed) in the .hserverrc file.
# Added Rovio
#
# Revision 1.5  2009/01/27 20:21:17  zkira
# Added gazebo laser_pitch parameter
#
# Revision 1.4  2008/11/20 03:53:57  ts2883
# The pitch angle information for the laser can now be parsed and read by the
# hserver using .hserverrc file.
#
# Revision 1.3  2008/09/16 16:47:38  zkira
# Added Gazebo robot class, clientID, and serverID to configuration file
#
# Revision 1.2  2008/07/15 22:34:02  endo
# OpenCV, Gazebo and USARSim added.
#
# Revision 1.11  2008/04/14 21:51:28  endo
# Regular backup.
#
# Revision 1.10  2008/04/13 00:33:42  endo
# Regular backup.
#
# Revision 1.9  2008/04/12 20:17:24  endo
# OpenCV face detection implemented.
#
# Revision 1.8  2008/01/13 00:35:40  endo
# Regular backup.
#
# Revision 1.7  2008/01/09 22:54:03  endo
# USARSimRobot added.
#
# Revision 1.6  2006/12/01 21:14:54  endo
# Regular backup.
#
# Revision 1.5  2006/11/29 00:01:45  endo
# OpenCV BlobTrack improved.
#
# Revision 1.4  2006/11/17 23:35:53  endo
# GazeboVideo implemented.
#
# Revision 1.3  2006/11/15 23:45:59  endo
# GazeboLaser can now accept the second laser.
#
# Revision 1.2  2006/08/08 21:33:49  endo
# GazeboLaser added.
#
# Revision 1.1.1.1  2006/07/21 17:42:17  endo
# HServer for Gazebo (based on MissionLab-7.0.20060712.tar.gz)
#
# Revision 1.1.1.1  2006/07/12 13:37:57  endo
# MissionLab 7.0
#
# Revision 1.3  2006/06/05 21:35:54  endo
# PoseCalculator from MARA 2020 migrated
#
# Revision 1.5  2004/11/22 00:19:22  endo
# Network query of JBox can now be disabled.
#
# Revision 1.4  2004/09/22 04:00:58  endo
# *** empty log message ***
#
# Revision 1.3  2004/09/10 20:05:05  endo
# New PoseCalc integrated.
#
# Revision 1.2  2004/04/24 11:20:54  endo
# 3DM-G added.
#
# Revision 1.1.1.1  2004/02/27 22:30:51  endo
# Initial MARS 2020 revision
#
# Revision 1.3  2003/04/26 18:31:06  ebeowulf
# Checked in Pioneer2-dxe module.
#
# Revision 1.2  2002/02/18 13:52:47  endo
# AmigoBot added.
#
#
#**********************************************************************/
