/**********************************************************************
 **                                                                  **
 **                     info_sharing.cc                               **
 **                                                                  **
 **                                                                  **
 **  Written by:  Zsolt Kira                                         **
 **                                                                  **
 **  This file contains functions for sharing of information between **
 **  robots regarding their positions, objects, etc.  This is done   **
 **  via the database broadcast mechanism.                           **
 **                                                                  **
 **  Copyright 2009, Georgia Tech Research Corporation               **
 **  Atlanta, Georgia  30332-0415                                    **
 **  ALL RIGHTS RESERVED, See file COPYRIGHT for details.            **
 **                                                                  **
 **********************************************************************/

#ifndef INFO_SHARING_H
#define INFO_SHARING_H

extern char* MSG_InfoSharingPosition;
#define FRM_InfoSharingPosition "{int, float, float, float}"
typedef struct REC_InfoSharingPosition
{
    int robot_id;
    float x;
    float y;
    float yaw;
};
//extern REC_InfoSharingPosition InfoSharingPosition; 

extern char* MSG_InfoSharingObject;
#define FRM_InfoSharingObject "{int, int, float, float, float}"
typedef struct REC_InfoSharingObject
{
    int robot_id;
    int object_id;
    float x;
    float y;
    float yaw;
};

class info_sharing_object {
public:
 int id;
 double x, y;
// char label[10000];
// char color[10000];
 double r;

  info_sharing_object() {
    id = 0;
    x = y = 0.0;
    //strcpy(label, "UNKNOWN");
    r = 0.0;
  }
};

class info_sharing_robot {
public:
 int id;
 double x, y, z;
 double roll, pitch, yaw;
 double r;

  info_sharing_robot() {
    id = 0;
    x = y = z = 0.0;
    roll = pitch = yaw = 0.0;
    r = 0.0;
  }
};

#endif
